from sys import setrecursionlimit

def main():
    N, M = map(int, input().split())
    
    dist = [0] * (N + 1)
    indeg = [0] * (N + 1)
    par = [0] * (N + 1)
    adj = [[] for _ in range(N + 1)]
    
    for _ in range(M):
        x, y = map(int, input().split())
        adj[x].append(y)
        indeg[y] += 1
        par[y] = x
    
    def dfs(x):
        nonlocal dist, adj
        if dist[x] > 0:
            return dist[x]

        d = 0
        for y in adj[x]:
            if dist[y] == 0:
                d = dfs(y)
            else:
                d = dist[y]
        d += 1
        dist[x] = d
        return d

    for i in range(1, N + 1):
        if indeg[i] == 0:
            dfs(i)
    
    lvl = [[] for _ in range(N + 1)]
    mxd = 0
    
    for i in range(1, N + 1):
        lvl[dist[i]].append(i)
        mxd = max(mxd, dist[i])

    ans = 2 * mxd
    for t in range(1, mxd + 1):
        if len(lvl[t]) == 1:
            ans -= 1
    
    A, B, C = [0] * (N + 1), [0] * (N + 1), [0] * (N + 1)

    a = lvl[mxd][0]
    b = a
    if len(lvl[mxd]) > 1:
        b = lvl[mxd][1]
    
    A[mxd], B[mxd] = a, b
    A[mxd + 1], B[mxd + 1] = 0, 0

    for t in range(mxd - 1, 0, -1):
        a = A[t + 1]
        b = B[t + 1]
        if a == b:
            aa = adj[a][0]
            if len(lvl[t]) > 1:
                bb = adj[a][1]
            else:
                bb = aa
            A[t] = aa
            B[t] = bb
            continue
        
        aa, bb = adj[a][0], adj[b][0]
        A[t], B[t] = aa, bb
        if aa != bb or len(lvl[t]) == 1:
            continue

        c = 0
        for x in lvl[t]:
            if x != aa:
                c = x
                break
        
        C[t] = c
        tt = t
        while True:
            c = par[c]
            tt += 1
            if tt > mxd:
                break
            C[tt] = c
            if A[tt] == c or B[tt] == c or tt == mxd:
                break
        
        if tt > mxd:
            tt -= 1
        
        if A[tt] == c:
            for it in range(tt, t - 1, -1):
                A[it] = C[it]
        else:
            for it in range(tt, t - 1, -1):
                B[it] = C[it]

    print(ans)
    print(" ".join(map(str, reversed(A[1:mxd+1]))) + " 0")
    print(" ".join(map(str, reversed(B[1:mxd+1]))) + " 0")

setrecursionlimit(5000)
main()
